package hoge.foo;

import java.util.Timer;
import java.util.TimerTask;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.RemoteException;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

public class MainActivity extends Activity {
	
	// A\Toast
	private Toast _mToast = null;

	// ^C}
	private final Timer _mTimer = new Timer();
	
	// ^C}ɓo^^XN
	private TimerTask _mTimerTask = new TimerTask() {
		@Override
		public void run() {
			
			// TimerTaskʕ\ύXꍇ́A
			// HandlerăCXbhpost
			_mHandler.post(new Runnable() {
				@Override
				public void run() {

					// Toast̕\
					_mToast.show();

				}
			});
		}
	};
	
	// nh
	private final Handler _mHandler = new Handler();

	// T[rXƂ̐ڑ
	private ITestService _mITestServiceBind = null;
	private ServiceConnection _mServiceConnection = new ServiceConnection() {

		@Override
		public void onServiceConnected(ComponentName name, IBinder service) {
			
			_mITestServiceBind = ITestService.Stub.asInterface(service);

		}

		@Override
		public void onServiceDisconnected(ComponentName name) {
			// TODO Auto-generated method stub
			
		}
		
	};

	private Button _mBtnStop = null;
	
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        // T[rXJn
        Intent intent = new Intent(this, TestService.class);
        startService(intent);

        // T[rXƂ̐ڑ
        // T[rXNĂȂꍇ͎ŋN
        bindService(intent, _mServiceConnection, BIND_AUTO_CREATE);

		// Toast쐬
		_mToast = Toast.makeText(this, "Activity is alive", Toast.LENGTH_LONG);

		// \ꏊύX - ʒ
		_mToast.setGravity(Gravity.CENTER, 0, 0);

		// ^C}ɓo^ 1bォA5bɂPATimerTasks
		_mTimer.schedule(_mTimerTask, 1000, 5 * 1000);

		_mBtnStop = (Button)findViewById(R.id.main_btn_stop);
		_mBtnStop.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				
				// T[rX~
				// mɂ́AToast̕\~
				try {
					_mITestServiceBind.stopService();
				} catch (RemoteException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});
    }
    
    /*
     * (non-Javadoc)
     * @see android.app.Activity#onStop()
     */
    @Override
    public void onStop() {
    	super.onStop();

    	// ^C}~
    	_mTimer.cancel();
    	
    	// T[rXƂ̐ڑ
    	unbindService(_mServiceConnection);
    }
}